/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-interaction-cursor-msgs-0.0.3-1precise-20150328-1145/msg/InteractionCursorFeedback.msg
 *
 */


#ifndef INTERACTION_CURSOR_MSGS_MESSAGE_INTERACTIONCURSORFEEDBACK_H
#define INTERACTION_CURSOR_MSGS_MESSAGE_INTERACTIONCURSORFEEDBACK_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/PoseStamped.h>

namespace interaction_cursor_msgs
{
template <class ContainerAllocator>
struct InteractionCursorFeedback_
{
  typedef InteractionCursorFeedback_<ContainerAllocator> Type;

  InteractionCursorFeedback_()
    : pose()
    , attachment_type(0)
    , event_type(0)  {
    }
  InteractionCursorFeedback_(const ContainerAllocator& _alloc)
    : pose(_alloc)
    , attachment_type(0)
    , event_type(0)  {
    }



   typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef uint8_t _attachment_type_type;
  _attachment_type_type attachment_type;

   typedef uint8_t _event_type_type;
  _event_type_type event_type;


    enum { NONE = 0 };
     enum { POSITION = 1 };
     enum { ORIENTATION = 2 };
     enum { POSITION_AND_ORIENTATION = 3 };
     enum { GRABBED = 1 };
     enum { KEEP_ALIVE = 2 };
     enum { RELEASED = 3 };
     enum { LOST_GRASP = 4 };
 

  typedef boost::shared_ptr< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct InteractionCursorFeedback_

typedef ::interaction_cursor_msgs::InteractionCursorFeedback_<std::allocator<void> > InteractionCursorFeedback;

typedef boost::shared_ptr< ::interaction_cursor_msgs::InteractionCursorFeedback > InteractionCursorFeedbackPtr;
typedef boost::shared_ptr< ::interaction_cursor_msgs::InteractionCursorFeedback const> InteractionCursorFeedbackConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace interaction_cursor_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'interaction_cursor_msgs': ['/tmp/buildd/ros-hydro-interaction-cursor-msgs-0.0.3-1precise-20150328-1145/msg'], 'visualization_msgs': ['/opt/ros/hydro/share/visualization_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "92dcfa34c8dfcb4f63d1d35ca54dc145";
  }

  static const char* value(const ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x92dcfa34c8dfcb4fULL;
  static const uint64_t static_value2 = 0x63d1d35ca54dc145ULL;
};

template<class ContainerAllocator>
struct DataType< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "interaction_cursor_msgs/InteractionCursorFeedback";
  }

  static const char* value(const ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# When the cursor attaches to an interactive_marker, this feedback \n\
# message contains the frame_id of the TF frame that the marker \n\
# is used to \"control\", if any. The pose records the pose of the \n\
# cursor relative to that frame at time of grasp.\n\
geometry_msgs/PoseStamped pose\n\
\n\
# Default for both event_type and attachment_type\n\
uint8 NONE = 0\n\
\n\
# Attachment types define what kind of virtual spring coupling there \n\
# is between the device and the grabbed object frame.\n\
uint8 POSITION = 1\n\
uint8 ORIENTATION = 2\n\
uint8 POSITION_AND_ORIENTATION = 3\n\
uint8 attachment_type\n\
\n\
# KEEP_ALIVE: should probably be sent regularly by Rviz, otherwise\n\
# the interaction app should assume that it has lost control of the marker.\n\
uint8 GRABBED = 1\n\
uint8 KEEP_ALIVE = 2\n\
uint8 RELEASED = 3\n\
uint8 LOST_GRASP = 4\n\
\n\
uint8 event_type\n\
\n\
\n\
\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pose);
      stream.next(m.attachment_type);
      stream.next(m.event_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct InteractionCursorFeedback_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::interaction_cursor_msgs::InteractionCursorFeedback_<ContainerAllocator>& v)
  {
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "attachment_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.attachment_type);
    s << indent << "event_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.event_type);
  }
};

} // namespace message_operations
} // namespace ros

#endif // INTERACTION_CURSOR_MSGS_MESSAGE_INTERACTIONCURSORFEEDBACK_H
